<?php

/**
 * Class extending the Shortcodes base class
 * for building the bubbleline element
 *
 * how to use :
 *
 * [bubbleline
 *   class="some class"
 *   id="someid"
 *   direction="horizontal|vertical"
 * ]
 *
 * [bubblelineitem
 *   id="x"
 *   class="class_one class_two"
 *   bubble___date="2016"
 *   bubble___text="the context text"
 *   bubble___color=""
 *   bubble___size="small"
 *   bubble___style="point"
 *   dot___radius=''
 *   dot___color=''
 *   dot___border_color=''
 *   dot___border_size=''
 *   text___color=''
 *   line___color=''
 *   line___width=''
 *   line___type=''
 *   line___mode="wave|normal|curve"
 * ]
 *
 *   some content for the inner shortcodes allowed
 *
 * [/bubblelineitem]
 *
 * [/bubbleline]
 *
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_BubbleLine_Shortcodes_BubbleLine
    extends VTCore_Wordpress_Models_VCShortcodes
    implements VTCore_Wordpress_Interfaces_Shortcodes
{

    protected $processDottedNotation = true;

    protected function processCustomRules()
    {

        if (!$this->get('direction')) {
            $this->add('direction', 'horizontal');
        }

        $this->add('attributes.class.direction', 'bubbleline-direction-' . $this->get('direction'));
    }

    public function buildObject()
    {
        $this->object = new VTCore_BubbleLine_Element_BubbleLine($this->atts);
        $this->object->addChildren(do_shortcode($this->content));
    }
}