<?php

/**
 * Class extending the Shortcodes base class
 * for building simple bubble line. This is created
 * for a very simple bubble line object for advanced
 * usage please us the normal bubbleline shortcode instead.
 *
 * how to use :
 *
 * [bubblelinesimple
 *   class="some class"
 *   id="someid"
 *   direction="horizontal|vertical"
 *   contentargs="url decoded arrays of content"
 * ]
 *
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_BubbleLine_Shortcodes_BubbleLineSimple
    extends VTCore_Wordpress_Models_VCShortcodes
    implements VTCore_Wordpress_Interfaces_Shortcodes
{

    protected $processDottedNotation = true;

    /**
     * Extending parent method.
     * @see VTCore_Wordpress_Models_Shortcodes::processCustomRules()
     */
    protected function processCustomRules()
    {
        if ($this->get('contentargs')) {
            $this->add('contents', json_decode(urldecode($this->get('contentargs')), true));
        }

        if (!$this->get('direction')) {
            $this->add('direction', 'horizontal');
        }

        $this->add('attributes.class.direction', 'bubbleline-direction-' . $this->get('direction'));
    }



    public function buildObject()
    {
        // Move animation to children
        $animation = $this->get('attributes.class.css_animation');
        $this->remove('attributes.class.css_animation');

        $this->object = new VTCore_BubbleLine_Element_BubbleLine($this->atts);

        if ($this->get('contents')) {
            $markup = '';
            foreach ($this->get('contents') as $delta => $content) {
                $data = new VTCore_Wordpress_Objects_Array($content);
                $data->add('bubble_element.attributes.class.css_animation', $animation);

                $shortcode = new VTCore_BubbleLine_Shortcodes_BubbleLineItem($data->extract(), $data->get('content'), 'bubblelineitem');
                $shortcode->buildObject();
                $markup .= $shortcode->getMarkup();
            }

            if (!empty($markup)) {
                $this->object->addChildren($markup);
            }
        }
    }
}


