+function($) {
  'use strict';

  // var for check event at body can have only one.
  var event_body = false;

  // CONFIRMATION PUBLIC CLASS DEFINITION
  // ===============================
  var Confirmation = function(element, options) {
    var that = this;

    this.init('confirmation', element, options);

    $(element).on('show.bs.confirmation', function(e) {
      that.options.onShow(e, this);

      $(this).addClass('open');

      var options = that.options;
      var all = options.all_selector;

      if (options.singleton) {
        $(all + '.in').not(that.$element).confirmation('hide');
      }
    });

    $(element).data('ajax-stop', true);

    $(element).on('hide.bs.confirmation', function(e) {
      that.options.onHide(e, this);

      $(this).removeClass('open');
    });

    $(element).on(
        'shown.bs.confirmation',
        function(e) {
          var options = that.options;
          var all = options.all_selector;

          that.$element.on('click.dismiss.bs.confirmation',
              '[data-dismiss="confirmation"]', $.proxy(that.hide, that));

          if (that.isPopout()) {
            if (!event_body) {
              event_body = $('body').on('click', function(e) {
                if (that.$element.is(e.target))
                  return;
                if (that.$element.has(e.target).length)
                  return;
                if ($('.popover').has(e.target).length)
                  return;

                that.$element.confirmation('hide');

                $('body').unbind(e);

                event_body = false;

                return;
              });
            }
          }
        });

    $(element).on('click', function(e) {
      e.preventDefault();
    });
}

if (!$.fn.popover || !$.fn.tooltip) {
    // Load tooltip
    if("undefined"==typeof jQuery)throw new Error("Bootstrap's JavaScript requires jQuery");+function(t){"use strict";var e=t.fn.jquery.split(" ")[0].split(".");if(e[0]<2&&e[1]<9||1==e[0]&&9==e[1]&&e[2]<1||e[0]>3)throw new Error("Bootstrap's JavaScript requires jQuery version 1.9.1 or higher, but lower than version 4")}(jQuery),+function(t){"use strict";function e(e){return this.each(function(){var i=t(this),n=i.data("bs.tooltip"),r="object"==typeof e&&e;!n&&/destroy|hide/.test(e)||(n||i.data("bs.tooltip",n=new o(this,r)),"string"==typeof e&&n[e]())})}var o=function(t,e){this.type=null,this.options=null,this.enabled=null,this.timeout=null,this.hoverState=null,this.$element=null,this.inState=null,this.init("tooltip",t,e)};o.VERSION="3.3.7",o.TRANSITION_DURATION=150,o.DEFAULTS={animation:!0,placement:"top",selector:!1,template:'<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',trigger:"hover focus",title:"",delay:0,html:!1,container:!1,viewport:{selector:"body",padding:0}},o.prototype.init=function(e,o,i){if(this.enabled=!0,this.type=e,this.$element=t(o),this.options=this.getOptions(i),this.$viewport=this.options.viewport&&t(t.isFunction(this.options.viewport)?this.options.viewport.call(this,this.$element):this.options.viewport.selector||this.options.viewport),this.inState={click:!1,hover:!1,focus:!1},this.$element[0]instanceof document.constructor&&!this.options.selector)throw new Error("`selector` option must be specified when initializing "+this.type+" on the window.document object!");for(var n=this.options.trigger.split(" "),r=n.length;r--;){var s=n[r];if("click"==s)this.$element.on("click."+this.type,this.options.selector,t.proxy(this.toggle,this));else if("manual"!=s){var p="hover"==s?"mouseenter":"focusin",a="hover"==s?"mouseleave":"focusout";this.$element.on(p+"."+this.type,this.options.selector,t.proxy(this.enter,this)),this.$element.on(a+"."+this.type,this.options.selector,t.proxy(this.leave,this))}}this.options.selector?this._options=t.extend({},this.options,{trigger:"manual",selector:""}):this.fixTitle()},o.prototype.getDefaults=function(){return o.DEFAULTS},o.prototype.getOptions=function(e){return e=t.extend({},this.getDefaults(),this.$element.data(),e),e.delay&&"number"==typeof e.delay&&(e.delay={show:e.delay,hide:e.delay}),e},o.prototype.getDelegateOptions=function(){var e={},o=this.getDefaults();return this._options&&t.each(this._options,function(t,i){o[t]!=i&&(e[t]=i)}),e},o.prototype.enter=function(e){var o=e instanceof this.constructor?e:t(e.currentTarget).data("bs."+this.type);return o||(o=new this.constructor(e.currentTarget,this.getDelegateOptions()),t(e.currentTarget).data("bs."+this.type,o)),e instanceof t.Event&&(o.inState["focusin"==e.type?"focus":"hover"]=!0),o.tip().hasClass("in")||"in"==o.hoverState?void(o.hoverState="in"):(clearTimeout(o.timeout),o.hoverState="in",o.options.delay&&o.options.delay.show?void(o.timeout=setTimeout(function(){"in"==o.hoverState&&o.show()},o.options.delay.show)):o.show())},o.prototype.isInStateTrue=function(){for(var t in this.inState)if(this.inState[t])return!0;return!1},o.prototype.leave=function(e){var o=e instanceof this.constructor?e:t(e.currentTarget).data("bs."+this.type);return o||(o=new this.constructor(e.currentTarget,this.getDelegateOptions()),t(e.currentTarget).data("bs."+this.type,o)),e instanceof t.Event&&(o.inState["focusout"==e.type?"focus":"hover"]=!1),o.isInStateTrue()?void 0:(clearTimeout(o.timeout),o.hoverState="out",o.options.delay&&o.options.delay.hide?void(o.timeout=setTimeout(function(){"out"==o.hoverState&&o.hide()},o.options.delay.hide)):o.hide())},o.prototype.show=function(){var e=t.Event("show.bs."+this.type);if(this.hasContent()&&this.enabled){this.$element.trigger(e);var i=t.contains(this.$element[0].ownerDocument.documentElement,this.$element[0]);if(e.isDefaultPrevented()||!i)return;var n=this,r=this.tip(),s=this.getUID(this.type);this.setContent(),r.attr("id",s),this.$element.attr("aria-describedby",s),this.options.animation&&r.addClass("fade");var p="function"==typeof this.options.placement?this.options.placement.call(this,r[0],this.$element[0]):this.options.placement,a=/\s?auto?\s?/i,l=a.test(p);l&&(p=p.replace(a,"")||"top"),r.detach().css({top:0,left:0,display:"block"}).addClass(p).data("bs."+this.type,this),this.options.container?r.appendTo(this.options.container):r.insertAfter(this.$element),this.$element.trigger("inserted.bs."+this.type);var h=this.getPosition(),f=r[0].offsetWidth,c=r[0].offsetHeight;if(l){var u=p,d=this.getPosition(this.$viewport);p="bottom"==p&&h.bottom+c>d.bottom?"top":"top"==p&&h.top-c<d.top?"bottom":"right"==p&&h.right+f>d.width?"left":"left"==p&&h.left-f<d.left?"right":p,r.removeClass(u).addClass(p)}var v=this.getCalculatedOffset(p,h,f,c);this.applyPlacement(v,p);var y=function(){var t=n.hoverState;n.$element.trigger("shown.bs."+n.type),n.hoverState=null,"out"==t&&n.leave(n)};t.support.transition&&this.$tip.hasClass("fade")?r.one("bsTransitionEnd",y).emulateTransitionEnd(o.TRANSITION_DURATION):y()}},o.prototype.applyPlacement=function(e,o){var i=this.tip(),n=i[0].offsetWidth,r=i[0].offsetHeight,s=parseInt(i.css("margin-top"),10),p=parseInt(i.css("margin-left"),10);isNaN(s)&&(s=0),isNaN(p)&&(p=0),e.top+=s,e.left+=p,t.offset.setOffset(i[0],t.extend({using:function(t){i.css({top:Math.round(t.top),left:Math.round(t.left)})}},e),0),i.addClass("in");var a=i[0].offsetWidth,l=i[0].offsetHeight;"top"==o&&l!=r&&(e.top=e.top+r-l);var h=this.getViewportAdjustedDelta(o,e,a,l);h.left?e.left+=h.left:e.top+=h.top;var f=/top|bottom/.test(o),c=f?2*h.left-n+a:2*h.top-r+l,u=f?"offsetWidth":"offsetHeight";i.offset(e),this.replaceArrow(c,i[0][u],f)},o.prototype.replaceArrow=function(t,e,o){this.arrow().css(o?"left":"top",50*(1-t/e)+"%").css(o?"top":"left","")},o.prototype.setContent=function(){var t=this.tip(),e=this.getTitle();t.find(".tooltip-inner")[this.options.html?"html":"text"](e),t.removeClass("fade in top bottom left right")},o.prototype.hide=function(e){function i(){"in"!=n.hoverState&&r.detach(),n.$element&&n.$element.removeAttr("aria-describedby").trigger("hidden.bs."+n.type),e&&e()}var n=this,r=t(this.$tip),s=t.Event("hide.bs."+this.type);return this.$element.trigger(s),s.isDefaultPrevented()?void 0:(r.removeClass("in"),t.support.transition&&r.hasClass("fade")?r.one("bsTransitionEnd",i).emulateTransitionEnd(o.TRANSITION_DURATION):i(),this.hoverState=null,this)},o.prototype.fixTitle=function(){var t=this.$element;(t.attr("title")||"string"!=typeof t.attr("data-original-title"))&&t.attr("data-original-title",t.attr("title")||"").attr("title","")},o.prototype.hasContent=function(){return this.getTitle()},o.prototype.getPosition=function(e){e=e||this.$element;var o=e[0],i="BODY"==o.tagName,n=o.getBoundingClientRect();null==n.width&&(n=t.extend({},n,{width:n.right-n.left,height:n.bottom-n.top}));var r=window.SVGElement&&o instanceof window.SVGElement,s=i?{top:0,left:0}:r?null:e.offset(),p={scroll:i?document.documentElement.scrollTop||document.body.scrollTop:e.scrollTop()},a=i?{width:t(window).width(),height:t(window).height()}:null;return t.extend({},n,p,a,s)},o.prototype.getCalculatedOffset=function(t,e,o,i){return"bottom"==t?{top:e.top+e.height,left:e.left+e.width/2-o/2}:"top"==t?{top:e.top-i,left:e.left+e.width/2-o/2}:"left"==t?{top:e.top+e.height/2-i/2,left:e.left-o}:{top:e.top+e.height/2-i/2,left:e.left+e.width}},o.prototype.getViewportAdjustedDelta=function(t,e,o,i){var n={top:0,left:0};if(!this.$viewport)return n;var r=this.options.viewport&&this.options.viewport.padding||0,s=this.getPosition(this.$viewport);if(/right|left/.test(t)){var p=e.top-r-s.scroll,a=e.top+r-s.scroll+i;p<s.top?n.top=s.top-p:a>s.top+s.height&&(n.top=s.top+s.height-a)}else{var l=e.left-r,h=e.left+r+o;l<s.left?n.left=s.left-l:h>s.right&&(n.left=s.left+s.width-h)}return n},o.prototype.getTitle=function(){var t,e=this.$element,o=this.options;return t=e.attr("data-original-title")||("function"==typeof o.title?o.title.call(e[0]):o.title)},o.prototype.getUID=function(t){do t+=~~(1e6*Math.random());while(document.getElementById(t));return t},o.prototype.tip=function(){if(!this.$tip&&(this.$tip=t(this.options.template),1!=this.$tip.length))throw new Error(this.type+" `template` option must consist of exactly 1 top-level element!");return this.$tip},o.prototype.arrow=function(){return this.$arrow=this.$arrow||this.tip().find(".tooltip-arrow")},o.prototype.enable=function(){this.enabled=!0},o.prototype.disable=function(){this.enabled=!1},o.prototype.toggleEnabled=function(){this.enabled=!this.enabled},o.prototype.toggle=function(e){var o=this;e&&(o=t(e.currentTarget).data("bs."+this.type),o||(o=new this.constructor(e.currentTarget,this.getDelegateOptions()),t(e.currentTarget).data("bs."+this.type,o))),e?(o.inState.click=!o.inState.click,o.isInStateTrue()?o.enter(o):o.leave(o)):o.tip().hasClass("in")?o.leave(o):o.enter(o)},o.prototype.destroy=function(){var t=this;clearTimeout(this.timeout),this.hide(function(){t.$element.off("."+t.type).removeData("bs."+t.type),t.$tip&&t.$tip.detach(),t.$tip=null,t.$arrow=null,t.$viewport=null,t.$element=null})};var i=t.fn.tooltip;t.fn.tooltip=e,t.fn.tooltip.Constructor=o,t.fn.tooltip.noConflict=function(){return t.fn.tooltip=i,this}}(jQuery);

    // Load popover
    if("undefined"==typeof jQuery)throw new Error("Bootstrap's JavaScript requires jQuery");+function(t){"use strict";var o=t.fn.jquery.split(" ")[0].split(".");if(o[0]<2&&o[1]<9||1==o[0]&&9==o[1]&&o[2]<1||o[0]>3)throw new Error("Bootstrap's JavaScript requires jQuery version 1.9.1 or higher, but lower than version 4")}(jQuery),+function(t){"use strict";function o(o){return this.each(function(){var r=t(this),n=r.data("bs.popover"),i="object"==typeof o&&o;!n&&/destroy|hide/.test(o)||(n||r.data("bs.popover",n=new e(this,i)),"string"==typeof o&&n[o]())})}var e=function(t,o){this.init("popover",t,o)};if(!t.fn.tooltip)throw new Error("Popover requires tooltip.js");e.VERSION="3.3.7",e.DEFAULTS=t.extend({},t.fn.tooltip.Constructor.DEFAULTS,{placement:"right",trigger:"click",content:"",template:'<div class="popover" role="tooltip"><div class="arrow"></div><h3 class="popover-title"></h3><div class="popover-content"></div></div>'}),e.prototype=t.extend({},t.fn.tooltip.Constructor.prototype),e.prototype.constructor=e,e.prototype.getDefaults=function(){return e.DEFAULTS},e.prototype.setContent=function(){var t=this.tip(),o=this.getTitle(),e=this.getContent();t.find(".popover-title")[this.options.html?"html":"text"](o),t.find(".popover-content").children().detach().end()[this.options.html?"string"==typeof e?"html":"append":"text"](e),t.removeClass("fade top bottom left right in"),t.find(".popover-title").html()||t.find(".popover-title").hide()},e.prototype.hasContent=function(){return this.getTitle()||this.getContent()},e.prototype.getContent=function(){var t=this.$element,o=this.options;return t.attr("data-content")||("function"==typeof o.content?o.content.call(t[0]):o.content)},e.prototype.arrow=function(){return this.$arrow=this.$arrow||this.tip().find(".arrow")};var r=t.fn.popover;t.fn.popover=o,t.fn.popover.Constructor=e,t.fn.popover.noConflict=function(){return t.fn.popover=r,this}}(jQuery);

    //throw new Error('Confirmation requires popover.js and tooltip.js');
}

Confirmation.DEFAULTS = $.extend({}, $.fn.popover.Constructor.DEFAULTS, {
    placement : 'right',
    title : 'Are you sure?',
    btnOkClass : 'btn btn-sm btn-danger',
    btnOkLabel : 'Delete',
    btnOkIcon : 'glyphicon glyphicon-ok',
    btnCancelClass : 'btn btn-sm btn-default',
    btnCancelLabel : 'Cancel',
    btnCancelIcon : 'glyphicon glyphicon-remove',
    href : '#',
    target : '_self',
    singleton : true,
    popout : true,
      onShow : function(event, element) {
    },
      onHide : function(event, element) {
    },
      onConfirm : function(event, element) {
    },
      onCancel : function(event, element) {
    },
    template : '<div class="popover"><div class="arrow"></div>'
        + '<h3 class="popover-title"></h3>' + '<div class="popover-content">'
        + '<a data-apply="confirmation">Yes</a>'
        + ' <a data-dismiss="confirmation">No</a>' + '</div>' + '</div>'
  });

  // NOTE: CONFIRMATION EXTENDS popover.js
  // ================================
  Confirmation.prototype = $.extend({}, $.fn.popover.Constructor.prototype);

  Confirmation.prototype.constructor = Confirmation;

  Confirmation.prototype.getDefaults = function() {
    return Confirmation.DEFAULTS;
  }

  Confirmation.prototype.setContent = function() {
    var that = this;
    var $tip = this.tip();
    var title = this.getTitle();
    var $btnOk = $tip.find('[data-apply="confirmation"]');
    var $btnCancel = $tip.find('[data-dismiss="confirmation"]');
    var options = this.options

    $btnOk.addClass(this.getBtnOkClass()).html(this.getBtnOkLabel()).prepend(
        $('<i></i>').addClass(this.getBtnOkIcon()), " ").attr('href',
        this.getHref()).attr('target', this.getTarget()).off('click').on(
        'click', function(event) {
          options.onConfirm(event, that.$element);

          that.$element.confirmation('hide');
          $tip.removeClass('fade top bottom left right in');
        });

    $btnCancel.addClass(this.getBtnCancelClass())
        .html(this.getBtnCancelLabel()).prepend(
            $('<i></i>').addClass(this.getBtnCancelIcon()), " ").off('click')
        .on('click', function(event) {
          options.onCancel(event, that.$element);

          that.$element.confirmation('hide');
          $tip.removeClass('fade top bottom left right in');
        });

    $tip.find('.popover-title')[this.options.html ? 'html' : 'text'](title);

    $tip.removeClass('fade top bottom left right in');

    // IE8 doesn't accept hiding via the `:empty` pseudo selector, we have to do
    // this manually by checking the contents.
    if (!$tip.find('.popover-title').html())
      $tip.find('.popover-title').hide();
  }

  Confirmation.prototype.getBtnOkClass = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnOkClass')
        || (typeof o.btnOkClass == 'function' ? o.btnOkClass.call($e[0])
            : o.btnOkClass);
  }

  Confirmation.prototype.getBtnOkLabel = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnOkLabel')
        || (typeof o.btnOkLabel == 'function' ? o.btnOkLabel.call($e[0])
            : o.btnOkLabel);
  }

  Confirmation.prototype.getBtnOkIcon = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnOkIcon')
        || (typeof o.btnOkIcon == 'function' ? o.btnOkIcon.call($e[0])
            : o.btnOkIcon);
  }

  Confirmation.prototype.getBtnCancelClass = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnCancelClass')
        || (typeof o.btnCancelClass == 'function' ? o.btnCancelClass
            .call($e[0]) : o.btnCancelClass);
  }

  Confirmation.prototype.getBtnCancelLabel = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnCancelLabel')
        || (typeof o.btnCancelLabel == 'function' ? o.btnCancelLabel
            .call($e[0]) : o.btnCancelLabel);
  }

  Confirmation.prototype.getBtnCancelIcon = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-btnCancelIcon')
        || (typeof o.btnCancelIcon == 'function' ? o.btnCancelIcon.call($e[0])
            : o.btnCancelIcon);
  }

  Confirmation.prototype.getHref = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-href')
        || (typeof o.href == 'function' ? o.href.call($e[0]) : o.href);
  }

  Confirmation.prototype.getTarget = function() {
    var $e = this.$element;
    var o = this.options;

    return $e.attr('data-target')
        || (typeof o.target == 'function' ? o.target.call($e[0]) : o.target);
  }

  Confirmation.prototype.isPopout = function() {
    var popout;
    var $e = this.$element;
    var o = this.options;

    popout = $e.attr('data-popout')
        || (typeof o.popout == 'function' ? o.popout.call($e[0]) : o.popout);

    if (popout == 'false')
      popout = false;

    return popout
  }

  // CONFIRMATION PLUGIN DEFINITION
  // =========================
  var old = $.fn.confirmation;

  $.fn.confirmation = function(option) {
    var that = this;

    return this
        .each(function() {
          var $this = $(this);
          var data = $this.data('bs.confirmation');
          var options = typeof option == 'object' && option;

          options = options || {};
          options.all_selector = that.selector;

          if (!data && option == 'destroy')
            return;
          if (!data)
            $this.data('bs.confirmation', (data = new Confirmation(this,
                options)));
          if (typeof option == 'string')
            data[option]();
        });
  }

  $.fn.confirmation.Constructor = Confirmation;

  // CONFIRMATION NO CONFLICT
  // ===================
  $.fn.confirmation.noConflict = function() {
    $.fn.confirmation = old;

    return this;
  }

  $(document).on('ajaxComplete', function() {
    $('[class^="btn-ajax"][data-toggle="confirmation"]').data('ajax-stop', true);
    $('[data-toggle="confirmation"]').confirmation({
      href: $(this).data('confirmation-target') || '#',
      onConfirm: function(event, element) {

        if (element.hasClass('btn-ajax') == false) {
          element.closest('form').append('<input type="hidden" name="' + element.attr('name') + '" value="' + element.attr('value') + '"/>').trigger('submit');
        }
        else {
          element.data('ajax-stop', false).trigger('click').data('ajax-stop', true);
        }
      }
    });

  });

  $('[class^="btn-ajax"][data-toggle="confirmation"]').data('ajax-stop', true);
  $('[data-toggle="confirmation"]').confirmation({
      href: $(this).data('confirmation-target') || '#',
      onConfirm: function(event, element) {

        if (element.hasClass('btn-ajax') == false) {
          element.closest('form').append('<input type="hidden" name="' + element.attr('name') + '" value="' + element.attr('value') + '"/>').trigger('submit');
        }
        else {
          element.data('ajax-stop', false).trigger('click').data('ajax-stop', true);
        }
      }
  });

}(jQuery);