(function ($) {
  $.fn.UItoTop = function (options) {
    var defaults = {
      text: 'To Top',
      min: 200,
      inDelay: 600,
      outDelay: 400,
      containerID: 'toTop',
      containerHoverID: 'toTopHover',
      scrollSpeed: 1200
    }, settings = $.extend(defaults, options), containerIDhash = '#' + settings.containerID, containerHoverIDHash = '#' + settings.containerHoverID;
    $('body').append('<a href="#" id="' + settings.containerID + '">' + settings.text + '</a>');
    $(containerIDhash).hide().on('click.UItoTop', function () {
      $('html, body').animate({scrollTop: 0}, settings.scrollSpeed);
      return false
    }).prepend('<span class="btn-primary" id="' + settings.containerHoverID + '"></span>');
    $(window).scroll(function () {
      var sd = $(window).scrollTop();
      if (typeof document.body.style.maxHeight === "undefined") {
        $(containerIDhash).css({
          'position': 'absolute',
          'top': sd + $(window).height() - 50
        })
      }
      if (sd > settings.min) {
        $(containerIDhash).addClass('open').removeClass('closed');
      }
      else {
        $(containerIDhash).removeClass('open').addClass('closed');
      }
    })
  }
})(jQuery);
// Auto booting
jQuery(document).ready(function ($) {
  $(document).UItoTop();
});