<?php
/**
 *
 * Class for building unique id
 *
 * @author jason.xie@victheme.com
 */
class VTCore_Uid {

  public static $uid = 0;

  /**
   * Construct and increase the id
   */
  public function __construct() {
    if (self::$uid == 0) {
      $this->setID();
    }
  }




  /**
   * Build first time unique id based on microtime
   */
  private function setID() {
    self::$uid = microtime(true);

    // Seems user server doesn't support microtime try using time
    if (self::$uid == 0) {
      self::$uid = time();
    }

    // user server doesn't support time or microtime use plain number instead
    if (self::$uid == 0) {
      self::$uid = 1;
    }

    // Clean decimals
    self::$uid = str_replace([',', '.'], '', self::$uid);
  }




  /**
   * Retrieve current unique id
   */
  public function getID() {
    return self::$uid++;
  }


}
