/**
 * Additional javascript for integrationg
 * VicTheme Core assets into wordpress widget
 * administration screen.
 *
 * @author jason.xie@victheme.com
 */
(function ($) {

    if (!window.VT) {
        window.VT = {};
    }

    $(document)
        .on('widget-added.vtcore-widgets', function (events, widget) {

            var Widget = $(widget), VTCore = Widget.find('.vtcore');

            if (VTCore.length == 0) {
                return;
            }

            // Remove useless bs select element
            Widget.length
                && Widget.find('.bootstrap-select').length
                && Widget.find('.bootstrap-select').remove();

            // Booting select picker
            if (typeof $.fn.selectpicker == 'function') {
                Widget.length
                && Widget.find('select.selectpicker').length
                && Widget.find('select.selectpicker').selectpicker();
            }

            if (VT && VT.BsToggleDependency) {
                Widget.find('[data-dependency]:not(.bs-toggle-dependency-processed)').each(function () {
                    $(this).data('bs-toggle-dependency', new VT.BsToggleDependency($(this)));
                    $(this).data('bs-toggle-dependency').toggle($(this));
                    $(this).addClass('bs-toggle-dependency-processed');
                });
            }

            // Rebooting accordion
            if (Widget.find('.panel-accordion.vtcore')) {
                Widget.find('.panel-accordion.vtcore').each(function() {
                    var ID = 'accordion-' + Math.random().toString(36).substr(2, 9),
                        Parent = $(this);

                    Parent
                        .find('[data-parent="#' + Parent.attr('id') + '"]')
                        .attr('id', ID)
                        .each(function() {
                            var toggleID = $(this).attr('href').replace('#', ''),
                                targetID = ID + '-' + toggleID;

                            Parent.find('#' + toggleID).attr('id', targetID);
                            $(this).attr('data-parent', '#' + ID).attr('href', '#' + targetID);
                        });
                });
            }
        });

})(jQuery);