<?php
/**
 * Data storage class for storing json object string
 * for currencies
 *
 * If you need to access the fonts object directly
 * $currencies = new VTCore_Wordpress_Data_Google_Iso();
 * $currencies->getObject();
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_Wordpress_Data_Currency_Iso {

  private $json = '
  {
      "aed": {
      "priority": 100,
      "iso_code": "AED",
      "name": "United Arab Emirates Dirham",
      "symbol": "د.إ",
      "alternate_symbols": ["DH", "Dhs"],
      "subunit": "Fils",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "784"
},
      "afn": {
      "priority": 100,
      "iso_code": "AFN",
      "name": "Afghan Afghani",
      "symbol": "؋",
      "alternate_symbols": ["Af", "Afs"],
      "subunit": "Pul",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "971"
},
      "all": {
      "priority": 100,
      "iso_code": "ALL",
      "name": "Albanian Lek",
      "symbol": "L",
      "alternate_symbols": ["Lek"],
      "subunit": "Qintar",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "008"
},
      "amd": {
      "priority": 100,
      "iso_code": "AMD",
      "name": "Armenian Dram",
      "symbol": "դր.",
      "alternate_symbols": ["dram"],
      "subunit": "Luma",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "051"
},
      "ang": {
      "priority": 100,
      "iso_code": "ANG",
      "name": "Netherlands Antillean Gulden",
      "symbol": "ƒ",
      "alternate_symbols": ["NAƒ", "NAf", "f"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x0192;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "532"
},
      "aoa": {
      "priority": 100,
      "iso_code": "AOA",
      "name": "Angolan Kwanza",
      "symbol": "Kz",
      "alternate_symbols": [],
      "subunit": "Cêntimo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "973"
},
      "ars": {
      "priority": 100,
      "iso_code": "ARS",
      "name": "Argentine Peso",
      "symbol": "$",
      "alternate_symbols": ["$m/n", "m$n"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "032"
},
      "aud": {
      "priority": 4,
      "iso_code": "AUD",
      "name": "Australian Dollar",
      "symbol": "$",
      "alternate_symbols": ["A$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "036"
},
      "awg": {
      "priority": 100,
      "iso_code": "AWG",
      "name": "Aruban Florin",
      "symbol": "ƒ",
      "alternate_symbols": ["Afl"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x0192;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "533"
},
      "azn": {
      "priority": 100,
      "iso_code": "AZN",
      "name": "Azerbaijani Manat",
      "symbol": null,
      "alternate_symbols": ["m", "man"],
      "subunit": "Qəpik",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "944"
},
      "bam": {
      "priority": 100,
      "iso_code": "BAM",
      "name": "Bosnia and Herzegovina Convertible Mark",
      "symbol": "КМ",
      "alternate_symbols": ["KM"],
      "subunit": "Fening",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "977"
},
      "bbd": {
      "priority": 100,
      "iso_code": "BBD",
      "name": "Barbadian Dollar",
      "symbol": "$",
      "alternate_symbols": ["Bds$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "052"
},
      "bdt": {
      "priority": 100,
      "iso_code": "BDT",
      "name": "Bangladeshi Taka",
      "symbol": "৳",
      "alternate_symbols": ["Tk"],
      "subunit": "Paisa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "050"
},
      "bgn": {
      "priority": 100,
      "iso_code": "BGN",
      "name": "Bulgarian Lev",
      "symbol": "лв",
      "alternate_symbols": ["lev", "leva", "лев", "лева"],
      "subunit": "Stotinka",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "975"
},
      "bhd": {
      "priority": 100,
      "iso_code": "BHD",
      "name": "Bahraini Dinar",
      "symbol": "ب.د",
      "alternate_symbols": ["BD"],
      "subunit": "Fils",
      "subunit_to_unit": 1000,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "048"
},
      "bif": {
      "priority": 100,
      "iso_code": "BIF",
      "name": "Burundian Franc",
      "symbol": "Fr",
      "alternate_symbols": ["FBu"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "108"
},
      "bmd": {
      "priority": 100,
      "iso_code": "BMD",
      "name": "Bermudian Dollar",
      "symbol": "$",
      "alternate_symbols": ["BD$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "060"
},
      "bnd": {
      "priority": 100,
      "iso_code": "BND",
      "name": "Brunei Dollar",
      "symbol": "$",
      "alternate_symbols": ["B$"],
      "subunit": "Sen",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "096"
},
      "bob": {
      "priority": 100,
      "iso_code": "BOB",
      "name": "Bolivian Boliviano",
      "symbol": "Bs.",
      "alternate_symbols": ["Bs"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "068"
},
      "brl": {
      "priority": 100,
      "iso_code": "BRL",
      "name": "Brazilian Real",
      "symbol": "R$ ",
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "R$",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "986"
},
      "bsd": {
      "priority": 100,
      "iso_code": "BSD",
      "name": "Bahamian Dollar",
      "symbol": "$",
      "alternate_symbols": ["B$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "044"
},
      "btn": {
      "priority": 100,
      "iso_code": "BTN",
      "name": "Bhutanese Ngultrum",
      "symbol": "Nu.",
      "alternate_symbols": ["Nu"],
      "subunit": "Chertrum",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "064"
},
      "bwp": {
      "priority": 100,
      "iso_code": "BWP",
      "name": "Botswana Pula",
      "symbol": "P",
      "alternate_symbols": [],
      "subunit": "Thebe",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "072"
},
      "byr": {
      "priority": 100,
      "iso_code": "BYR",
      "name": "Belarusian Ruble",
      "symbol": "Br",
      "alternate_symbols": [""],
      "subunit": "Kapyeyka",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "974"
},
      "bzd": {
      "priority": 100,
      "iso_code": "BZD",
      "name": "Belize Dollar",
      "symbol": "$",
      "alternate_symbols": ["BZ$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "084"
},
      "cad": {
      "priority": 5,
      "iso_code": "CAD",
      "name": "Canadian Dollar",
      "symbol": "$",
      "alternate_symbols": ["C$", "CAD$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "124"
},
      "cdf": {
      "priority": 100,
      "iso_code": "CDF",
      "name": "Congolese Franc",
      "symbol": "Fr",
      "alternate_symbols": ["FC"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "976"
},
      "chf": {
      "priority": 100,
      "iso_code": "CHF",
      "name": "Swiss Franc",
      "symbol": "Fr",
      "alternate_symbols": ["SFr", "CHF"],
      "subunit": "Rappen",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "756"
},
      "clf": {
      "priority": 100,
      "iso_code": "CLF",
      "name": "Unidad de Fomento",
      "symbol": "UF",
      "alternate_symbols": [],
      "subunit": "Peso",
      "subunit_to_unit": 1,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "990"
},
      "clp": {
      "priority": 100,
      "iso_code": "CLP",
      "name": "Chilean Peso",
      "symbol": "$",
      "alternate_symbols": [],
      "subunit": "Peso",
      "subunit_to_unit": 1,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "152"
},
      "cny": {
      "priority": 100,
      "iso_code": "CNY",
      "name": "Chinese Renminbi Yuan",
      "symbol": "¥",
      "alternate_symbols": ["CN¥", "元", "CN元"],
      "subunit": "Fen",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x5713;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "156"
},
      "cop": {
      "priority": 100,
      "iso_code": "COP",
      "name": "Colombian Peso",
      "symbol": "$",
      "alternate_symbols": ["COL$"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "170"
},
      "crc": {
      "priority": 100,
      "iso_code": "CRC",
      "name": "Costa Rican Colón",
      "symbol": "₡",
      "alternate_symbols": ["¢"],
      "subunit": "Céntimo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20A1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "188"
},
      "cuc": {
      "priority": 100,
      "iso_code": "CUC",
      "name": "Cuban Convertible Peso",
      "symbol": "$",
      "alternate_symbols": ["CUC$"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "931"
},
      "cup": {
      "priority": 100,
      "iso_code": "CUP",
      "name": "Cuban Peso",
      "symbol": "$",
      "alternate_symbols": ["$MN"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "192"
},
      "cve": {
      "priority": 100,
      "iso_code": "CVE",
      "name": "Cape Verdean Escudo",
      "symbol": "$",
      "alternate_symbols": ["Esc"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "132"
},
      "czk": {
      "priority": 100,
      "iso_code": "CZK",
      "name": "Czech Koruna",
      "symbol": "Kč",
      "alternate_symbols": [],
      "subunit": "Haléř",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "203"
},
      "djf": {
      "priority": 100,
      "iso_code": "DJF",
      "name": "Djiboutian Franc",
      "symbol": "Fdj",
      "alternate_symbols": [],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "262"
},
      "dkk": {
      "priority": 100,
      "iso_code": "DKK",
      "name": "Danish Krone",
      "symbol": "kr",
      "alternate_symbols": [",-"],
      "subunit": "Øre",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "208"
},
      "dop": {
      "priority": 100,
      "iso_code": "DOP",
      "name": "Dominican Peso",
      "symbol": "$",
      "alternate_symbols": ["RD$"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "214"
},
      "dzd": {
      "priority": 100,
      "iso_code": "DZD",
      "name": "Algerian Dinar",
      "symbol": "د.ج",
      "alternate_symbols": ["DA"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "012"
},
      "egp": {
      "priority": 100,
      "iso_code": "EGP",
      "name": "Egyptian Pound",
      "symbol": "ج.م",
      "alternate_symbols": ["LE", "E£", "L.E."],
      "subunit": "Piastre",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "818"
},
      "ern": {
      "priority": 100,
      "iso_code": "ERN",
      "name": "Eritrean Nakfa",
      "symbol": "Nfk",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "232"
},
      "etb": {
      "priority": 100,
      "iso_code": "ETB",
      "name": "Ethiopian Birr",
      "symbol": "Br",
      "alternate_symbols": [],
      "subunit": "Santim",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "230"
},
      "eur": {
      "priority": 2,
      "iso_code": "EUR",
      "name": "Euro",
      "symbol": "€",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20AC;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "978"
},
      "fjd": {
      "priority": 100,
      "iso_code": "FJD",
      "name": "Fijian Dollar",
      "symbol": "$",
      "alternate_symbols": ["FJ$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "242"
},
      "fkp": {
      "priority": 100,
      "iso_code": "FKP",
      "name": "Falkland Pound",
      "symbol": "£",
      "alternate_symbols": ["FK£"],
      "subunit": "Penny",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "238"
},
      "gbp": {
      "priority": 3,
      "iso_code": "GBP",
      "name": "British Pound",
      "symbol": "£",
      "alternate_symbols": [],
      "subunit": "Penny",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "826"
},
      "gel": {
      "priority": 100,
      "iso_code": "GEL",
      "name": "Georgian Lari",
      "symbol": "ლ",
      "alternate_symbols": ["lari"],
      "subunit": "Tetri",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "981"
},
      "ghs": {
      "priority": 100,
      "iso_code": "GHS",
      "name": "Ghanaian Cedi",
      "symbol": "₵",
      "alternate_symbols": ["GH¢", "GH₵"],
      "subunit": "Pesewa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B5;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "936"
},
      "gip": {
      "priority": 100,
      "iso_code": "GIP",
      "name": "Gibraltar Pound",
      "symbol": "£",
      "alternate_symbols": [],
      "subunit": "Penny",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "292"
},
      "gmd": {
      "priority": 100,
      "iso_code": "GMD",
      "name": "Gambian Dalasi",
      "symbol": "D",
      "alternate_symbols": [],
      "subunit": "Butut",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "270"
},
      "gnf": {
      "priority": 100,
      "iso_code": "GNF",
      "name": "Guinean Franc",
      "symbol": "Fr",
      "alternate_symbols": ["FG", "GFr"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "324"
},
      "gtq": {
      "priority": 100,
      "iso_code": "GTQ",
      "name": "Guatemalan Quetzal",
      "symbol": "Q",
      "alternate_symbols": [],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "320"
},
      "gyd": {
      "priority": 100,
      "iso_code": "GYD",
      "name": "Guyanese Dollar",
      "symbol": "$",
      "alternate_symbols": ["G$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "328"
},
      "hkd": {
      "priority": 100,
      "iso_code": "HKD",
      "name": "Hong Kong Dollar",
      "symbol": "$",
      "alternate_symbols": ["HK$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "344"
},
      "hnl": {
      "priority": 100,
      "iso_code": "HNL",
      "name": "Honduran Lempira",
      "symbol": "L",
      "alternate_symbols": [],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "340"
},
      "hrk": {
      "priority": 100,
      "iso_code": "HRK",
      "name": "Croatian Kuna",
      "symbol": "kn",
      "alternate_symbols": [],
      "subunit": "Lipa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "191"
},
      "htg": {
      "priority": 100,
      "iso_code": "HTG",
      "name": "Haitian Gourde",
      "symbol": "G",
      "alternate_symbols": [],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "332"
},
      "huf": {
      "priority": 100,
      "iso_code": "HUF",
      "name": "Hungarian Forint",
      "symbol": "Ft",
      "alternate_symbols": [],
      "subunit": "Fillér",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "348"
},
      "idr": {
      "priority": 100,
      "iso_code": "IDR",
      "name": "Indonesian Rupiah",
      "symbol": "Rp",
      "alternate_symbols": [],
      "subunit": "Sen",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "360"
},
      "ils": {
      "priority": 100,
      "iso_code": "ILS",
      "name": "Israeli New Sheqel",
      "symbol": "₪",
      "alternate_symbols": ["ש״ח", "NIS"],
      "subunit": "Agora",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20AA;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "376"
},
      "inr": {
      "priority": 100,
      "iso_code": "INR",
      "name": "Indian Rupee",
      "symbol": "₹",
      "alternate_symbols": ["Rs", "৳", "૱", "௹", "रु", "₨"],
      "subunit": "Paisa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20b9;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "356"
},
      "iqd": {
      "priority": 100,
      "iso_code": "IQD",
      "name": "Iraqi Dinar",
      "symbol": "ع.د",
      "alternate_symbols": [],
      "subunit": "Fils",
      "subunit_to_unit": 1000,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "368"
},
      "irr": {
      "priority": 100,
      "iso_code": "IRR",
      "name": "Iranian Rial",
      "symbol": "﷼",
      "alternate_symbols": [],
      "subunit": "Dinar",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#xFDFC;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "364"
},
      "isk": {
      "priority": 100,
      "iso_code": "ISK",
      "name": "Icelandic Króna",
      "symbol": "kr",
      "alternate_symbols": ["Íkr"],
      "subunit": "Eyrir",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "352"
},
      "jmd": {
      "priority": 100,
      "iso_code": "JMD",
      "name": "Jamaican Dollar",
      "symbol": "$",
      "alternate_symbols": ["J$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "388"
},
      "jod": {
      "priority": 100,
      "iso_code": "JOD",
      "name": "Jordanian Dinar",
      "symbol": "د.ا",
      "alternate_symbols": ["JD"],
      "subunit": "Piastre",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "400"
},
      "jpy": {
      "priority": 6,
      "iso_code": "JPY",
      "name": "Japanese Yen",
      "symbol": "¥",
      "alternate_symbols": ["円", "圓"],
      "subunit": null,
      "subunit_to_unit": 1,
      "symbol_first": true,
      "html_entity": "&#x00A5;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "392"
},
      "kes": {
      "priority": 100,
      "iso_code": "KES",
      "name": "Kenyan Shilling",
      "symbol": "KSh",
      "alternate_symbols": ["Sh"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "404"
},
      "kgs": {
      "priority": 100,
      "iso_code": "KGS",
      "name": "Kyrgyzstani Som",
      "symbol": "som",
      "alternate_symbols": ["сом"],
      "subunit": "Tyiyn",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "417"
},
      "khr": {
      "priority": 100,
      "iso_code": "KHR",
      "name": "Cambodian Riel",
      "symbol": "៛",
      "alternate_symbols": [],
      "subunit": "Sen",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x17DB;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "116"
},
      "kmf": {
      "priority": 100,
      "iso_code": "KMF",
      "name": "Comorian Franc",
      "symbol": "Fr",
      "alternate_symbols": ["CF"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "174"
},
      "kpw": {
      "priority": 100,
      "iso_code": "KPW",
      "name": "North Korean Won",
      "symbol": "₩",
      "alternate_symbols": [],
      "subunit": "Chŏn",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20A9;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "408"
},
      "krw": {
      "priority": 100,
      "iso_code": "KRW",
      "name": "South Korean Won",
      "symbol": "₩",
      "subunit": null,
      "subunit_to_unit": 1,
      "alternate_symbols": [],
      "symbol_first": true,
      "html_entity": "&#x20A9;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "410"
},
      "kwd": {
      "priority": 100,
      "iso_code": "KWD",
      "name": "Kuwaiti Dinar",
      "symbol": "د.ك",
      "alternate_symbols": ["K.D."],
      "subunit": "Fils",
      "subunit_to_unit": 1000,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "414"
},
      "kyd": {
      "priority": 100,
      "iso_code": "KYD",
      "name": "Cayman Islands Dollar",
      "symbol": "$",
      "alternate_symbols": ["CI$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "136"
},
      "kzt": {
      "priority": 100,
      "iso_code": "KZT",
      "name": "Kazakhstani Tenge",
      "symbol": "〒",
      "alternate_symbols": [],
      "subunit": "Tiyn",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "398"
},
      "lak": {
      "priority": 100,
      "iso_code": "LAK",
      "name": "Lao Kip",
      "symbol": "₭",
      "alternate_symbols": ["₭N"],
      "subunit": "Att",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20AD;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "418"
},
      "lbp": {
      "priority": 100,
      "iso_code": "LBP",
      "name": "Lebanese Pound",
      "symbol": "ل.ل",
      "alternate_symbols": ["£", "L£"],
      "subunit": "Piastre",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "422"
},
      "lkr": {
      "priority": 100,
      "iso_code": "LKR",
      "name": "Sri Lankan Rupee",
      "symbol": "₨",
      "alternate_symbols": ["රු", "ரூ", "SLRs", "/-"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x0BF9;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "144"
},
      "lrd": {
      "priority": 100,
      "iso_code": "LRD",
      "name": "Liberian Dollar",
      "symbol": "$",
      "alternate_symbols": ["L$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "430"
},
      "lsl": {
      "priority": 100,
      "iso_code": "LSL",
      "name": "Lesotho Loti",
      "symbol": "L",
      "alternate_symbols": ["M"],
      "subunit": "Sente",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "426"
},
      "ltl": {
      "priority": 100,
      "iso_code": "LTL",
      "name": "Lithuanian Litas",
      "symbol": "Lt",
      "alternate_symbols": [],
      "subunit": "Centas",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "440"
},
      "lvl": {
      "priority": 100,
      "iso_code": "LVL",
      "name": "Latvian Lats",
      "symbol": "Ls",
      "alternate_symbols": [],
      "subunit": "Santīms",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "428"
},
      "lyd": {
      "priority": 100,
      "iso_code": "LYD",
      "name": "Libyan Dinar",
      "symbol": "ل.د",
      "alternate_symbols": ["LD"],
      "subunit": "Dirham",
      "subunit_to_unit": 1000,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "434"
},
      "mad": {
      "priority": 100,
      "iso_code": "MAD",
      "name": "Moroccan Dirham",
      "symbol": "د.م.",
      "alternate_symbols": [],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "504"
},
      "mdl": {
      "priority": 100,
      "iso_code": "MDL",
      "name": "Moldovan Leu",
      "symbol": "L",
      "alternate_symbols": ["lei"],
      "subunit": "Ban",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "498"
},
      "mga": {
      "priority": 100,
      "iso_code": "MGA",
      "name": "Malagasy Ariary",
      "symbol": "Ar",
      "alternate_symbols": [],
      "subunit": "Iraimbilanja",
      "subunit_to_unit": 5,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "969"
},
      "mkd": {
      "priority": 100,
      "iso_code": "MKD",
      "name": "Macedonian Denar",
      "symbol": "ден",
      "alternate_symbols": [],
      "subunit": "Deni",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "807"
},
      "mmk": {
      "priority": 100,
      "iso_code": "MMK",
      "name": "Myanmar Kyat",
      "symbol": "K",
      "alternate_symbols": [],
      "subunit": "Pya",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "104"
},
      "mnt": {
      "priority": 100,
      "iso_code": "MNT",
      "name": "Mongolian Tögrög",
      "symbol": "₮",
      "alternate_symbols": [],
      "subunit": "Möngö",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20AE;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "496"
},
      "mop": {
      "priority": 100,
      "iso_code": "MOP",
      "name": "Macanese Pataca",
      "symbol": "P",
      "alternate_symbols": ["MOP$"],
      "subunit": "Avo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "446"
},
      "mro": {
      "priority": 100,
      "iso_code": "MRO",
      "name": "Mauritanian Ouguiya",
      "symbol": "UM",
      "alternate_symbols": [],
      "subunit": "Khoums",
      "subunit_to_unit": 5,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "478"
},
      "mur": {
      "priority": 100,
      "iso_code": "MUR",
      "name": "Mauritian Rupee",
      "symbol": "₨",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20A8;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "480"
},
      "mvr": {
      "priority": 100,
      "iso_code": "MVR",
      "name": "Maldivian Rufiyaa",
      "symbol": "MVR",
      "alternate_symbols": ["MRF", "Rf", "/-", "ރ"],
      "subunit": "Laari",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "462"
},
      "mwk": {
      "priority": 100,
      "iso_code": "MWK",
      "name": "Malawian Kwacha",
      "symbol": "MK",
      "alternate_symbols": [],
      "subunit": "Tambala",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "454"
},
      "mxn": {
      "priority": 100,
      "iso_code": "MXN",
      "name": "Mexican Peso",
      "symbol": "$",
      "alternate_symbols": ["MEX$"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "484"
},
      "myr": {
      "priority": 100,
      "iso_code": "MYR",
      "name": "Malaysian Ringgit",
      "symbol": "RM",
      "alternate_symbols": [],
      "subunit": "Sen",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "458"
},
      "mzn": {
      "priority": 100,
      "iso_code": "MZN",
      "name": "Mozambican Metical",
      "symbol": "MTn",
      "alternate_symbols": ["MZN"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "943"
},
      "nad": {
      "priority": 100,
      "iso_code": "NAD",
      "name": "Namibian Dollar",
      "symbol": "$",
      "alternate_symbols": ["N$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "516"
},
      "ngn": {
      "priority": 100,
      "iso_code": "NGN",
      "name": "Nigerian Naira",
      "symbol": "₦",
      "alternate_symbols": [],
      "subunit": "Kobo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20A6;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "566"
},
      "nio": {
      "priority": 100,
      "iso_code": "NIO",
      "name": "Nicaraguan Córdoba",
      "symbol": "C$",
      "alternate_symbols": [],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "558"
},
      "nok": {
      "priority": 100,
      "iso_code": "NOK",
      "name": "Norwegian Krone",
      "symbol": "kr",
      "alternate_symbols": [",-"],
      "subunit": "Øre",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "kr",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "578"
},
      "npr": {
      "priority": 100,
      "iso_code": "NPR",
      "name": "Nepalese Rupee",
      "symbol": "₨",
      "alternate_symbols": ["Rs", "रू"],
      "subunit": "Paisa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20A8;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "524"
},
      "nzd": {
      "priority": 100,
      "iso_code": "NZD",
      "name": "New Zealand Dollar",
      "symbol": "$",
      "alternate_symbols": ["NZ$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "554"
},
      "omr": {
      "priority": 100,
      "iso_code": "OMR",
      "name": "Omani Rial",
      "symbol": "ر.ع.",
      "alternate_symbols": [],
      "subunit": "Baisa",
      "subunit_to_unit": 1000,
      "symbol_first": true,
      "html_entity": "&#xFDFC;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "512"
},
      "pab": {
      "priority": 100,
      "iso_code": "PAB",
      "name": "Panamanian Balboa",
      "symbol": "B/.",
      "alternate_symbols": [],
      "subunit": "Centésimo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "590"
},
      "pen": {
      "priority": 100,
      "iso_code": "PEN",
      "name": "Peruvian Nuevo Sol",
      "symbol": "S/.",
      "alternate_symbols": [],
      "subunit": "Céntimo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "S/.",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "604"
},
      "pgk": {
      "priority": 100,
      "iso_code": "PGK",
      "name": "Papua New Guinean Kina",
      "symbol": "K",
      "alternate_symbols": [],
      "subunit": "Toea",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "598"
},
      "php": {
      "priority": 100,
      "iso_code": "PHP",
      "name": "Philippine Peso",
      "symbol": "₱",
      "alternate_symbols": ["PHP", "PhP", "P"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "608"
},
      "pkr": {
      "priority": 100,
      "iso_code": "PKR",
      "name": "Pakistani Rupee",
      "symbol": "₨",
      "alternate_symbols": ["Rs"],
      "subunit": "Paisa",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20A8;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "586"
},
      "pln": {
      "priority": 100,
      "iso_code": "PLN",
      "name": "Polish Złoty",
      "symbol": "zł",
      "alternate_symbols": [],
      "subunit": "Grosz",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "z&#322;",
      "decimal_mark": ",",
      "thousands_separator": " ",
      "iso_numeric": "985"
},
      "pyg": {
      "priority": 100,
      "iso_code": "PYG",
      "name": "Paraguayan Guaraní",
      "symbol": "₲",
      "alternate_symbols": [],
      "subunit": "Céntimo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B2;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "600"
},
      "qar": {
      "priority": 100,
      "iso_code": "QAR",
      "name": "Qatari Riyal",
      "symbol": "ر.ق",
      "alternate_symbols": ["QR"],
      "subunit": "Dirham",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#xFDFC;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "634"
},
      "ron": {
      "priority": 100,
      "iso_code": "RON",
      "name": "Romanian Leu",
      "symbol": "Lei",
      "alternate_symbols": [],
      "subunit": "Bani",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "946"
},
      "rsd": {
      "priority": 100,
      "iso_code": "RSD",
      "name": "Serbian Dinar",
      "symbol": "РСД",
      "alternate_symbols": ["RSD", "din", "дин"],
      "subunit": "Para",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "941"
},
      "rub": {
      "priority": 100,
      "iso_code": "RUB",
      "name": "Russian Ruble",
      "symbol": "р.",
      "alternate_symbols": ["руб"],
      "subunit": "Kopek",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x0440;&#x0443;&#x0431;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "643"
},
      "rwf": {
      "priority": 100,
      "iso_code": "RWF",
      "name": "Rwandan Franc",
      "symbol": "FRw",
      "alternate_symbols": ["RF", "R₣"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "646"
},
      "sar": {
      "priority": 100,
      "iso_code": "SAR",
      "name": "Saudi Riyal",
      "symbol": "ر.س",
      "alternate_symbols": ["SR", "﷼"],
      "subunit": "Hallallah",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#xFDFC;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "682"
},
      "sbd": {
      "priority": 100,
      "iso_code": "SBD",
      "name": "Solomon Islands Dollar",
      "symbol": "$",
      "alternate_symbols": ["SI$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "090"
},
      "scr": {
      "priority": 100,
      "iso_code": "SCR",
      "name": "Seychellois Rupee",
      "symbol": "₨",
      "alternate_symbols": ["SRe", "SR"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20A8;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "690"
},
      "sdg": {
      "priority": 100,
      "iso_code": "SDG",
      "name": "Sudanese Pound",
      "symbol": "£",
      "alternate_symbols": [],
      "subunit": "Piastre",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "938"
},
      "sek": {
      "priority": 100,
      "iso_code": "SEK",
      "name": "Swedish Krona",
      "symbol": "kr",
      "alternate_symbols": [":-"],
      "subunit": "Öre",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": " ",
      "iso_numeric": "752"
},
      "sgd": {
      "priority": 100,
      "iso_code": "SGD",
      "name": "Singapore Dollar",
      "symbol": "$",
      "alternate_symbols": ["S$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "702"
},
      "shp": {
      "priority": 100,
      "iso_code": "SHP",
      "name": "Saint Helenian Pound",
      "symbol": "£",
      "alternate_symbols": [],
      "subunit": "Penny",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "654"
},
      "skk": {
      "priority": 100,
      "iso_code": "SKK",
      "name": "Slovak Koruna",
      "symbol": "Sk",
      "alternate_symbols": [],
      "subunit": "Halier",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "703"
},
      "sll": {
      "priority": 100,
      "iso_code": "SLL",
      "name": "Sierra Leonean Leone",
      "symbol": "Le",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "694"
},
      "sos": {
      "priority": 100,
      "iso_code": "SOS",
      "name": "Somali Shilling",
      "symbol": "Sh",
      "alternate_symbols": ["Sh.So"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "706"
},
      "srd": {
      "priority": 100,
      "iso_code": "SRD",
      "name": "Surinamese Dollar",
      "symbol": "$",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "968"
},
      "ssp": {
      "priority": 100,
      "iso_code": "SHP",
      "name": "South Sudanese Pound",
      "symbol": "£",
      "alternate_symbols": [],
      "subunit": "piaster",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "728"
},
      "std": {
      "priority": 100,
      "iso_code": "STD",
      "name": "São Tomé and Príncipe Dobra",
      "symbol": "Db",
      "alternate_symbols": [],
      "subunit": "Cêntimo",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "678"
},
      "svc": {
      "priority": 100,
      "iso_code": "SVC",
      "name": "Salvadoran Colón",
      "symbol": "₡",
      "alternate_symbols": ["¢"],
      "subunit": "Centavo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20A1;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "222"
},
      "syp": {
      "priority": 100,
      "iso_code": "SYP",
      "name": "Syrian Pound",
      "symbol": "£S",
      "alternate_symbols": ["£", "ل.س", "LS", "الليرة السورية"],
      "subunit": "Piastre",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x00A3;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "760"
},
      "szl": {
      "priority": 100,
      "iso_code": "SZL",
      "name": "Swazi Lilangeni",
      "symbol": "L",
      "alternate_symbols": ["E"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "748"
},
      "thb": {
      "priority": 100,
      "iso_code": "THB",
      "name": "Thai Baht",
      "symbol": "฿",
      "alternate_symbols": [],
      "subunit": "Satang",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x0E3F;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "764"
},
      "tjs": {
      "priority": 100,
      "iso_code": "TJS",
      "name": "Tajikistani Somoni",
      "symbol": "ЅМ",
      "alternate_symbols": [],
      "subunit": "Diram",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "972"
},
      "tmt": {
      "priority": 100,
      "iso_code": "TMM",
      "name": "Turkmenistani Manat",
      "symbol": "m",
      "alternate_symbols": [],
      "subunit": "Tennesi",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "934"
},
      "tnd": {
      "priority": 100,
      "iso_code": "TND",
      "name": "Tunisian Dinar",
      "symbol": "د.ت",
      "alternate_symbols": ["TD", "DT"],
      "subunit": "Millime",
      "subunit_to_unit": 1000,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "788"
},
      "top": {
      "priority": 100,
      "iso_code": "TOP",
      "name": "Tongan Paʻanga",
      "symbol": "T$",
      "alternate_symbols": ["PT"],
      "subunit": "Seniti",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "776"
},
      "try": {
      "priority": 100,
      "iso_code": "TRY",
      "name": "Turkish Lira",
      "symbol": "TL",
      "alternate_symbols": [],
      "subunit": "kuruş",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "949"
},
      "ttd": {
      "priority": 100,
      "iso_code": "TTD",
      "name": "Trinidad and Tobago Dollar",
      "symbol": "$",
      "alternate_symbols": ["TT$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "780"
},
      "twd": {
      "priority": 100,
      "iso_code": "TWD",
      "name": "New Taiwan Dollar",
      "symbol": "$",
      "alternate_symbols": ["NT$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "901"
},
      "tzs": {
      "priority": 100,
      "iso_code": "TZS",
      "name": "Tanzanian Shilling",
      "symbol": "Sh",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "834"
},
      "uah": {
      "priority": 100,
      "iso_code": "UAH",
      "name": "Ukrainian Hryvnia",
      "symbol": "₴",
      "alternate_symbols": [],
      "subunit": "Kopiyka",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#x20B4",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "980"
},
      "ugx": {
      "priority": 100,
      "iso_code": "UGX",
      "name": "Ugandan Shilling",
      "symbol": "USh",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "800"
},
      "usd": {
      "priority": 1,
      "iso_code": "USD",
      "name": "United States Dollar",
      "symbol": "$",
      "alternate_symbols": ["US$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "840"
},
      "uyu": {
      "priority": 100,
      "iso_code": "UYU",
      "name": "Uruguayan Peso",
      "symbol": "$",
      "alternate_symbols": ["$U"],
      "subunit": "Centésimo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x20B1;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "858"
},
      "uzs": {
      "priority": 100,
      "iso_code": "UZS",
      "name": "Uzbekistani Som",
      "symbol": null,
      "alternate_symbols": [],
      "subunit": "Tiyin",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "860"
},
      "vef": {
      "priority": 100,
      "iso_code": "VEF",
      "name": "Venezuelan Bolívar",
      "symbol": "Bs F",
      "alternate_symbols": ["Bs.F", "Bs"],
      "subunit": "Céntimo",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "937"
},
      "vnd": {
      "priority": 100,
      "iso_code": "VND",
      "name": "Vietnamese Đồng",
      "symbol": "₫",
      "alternate_symbols": [],
      "subunit": "Hào",
      "subunit_to_unit": 10,
      "symbol_first": true,
      "html_entity": "&#x20AB;",
      "decimal_mark": ",",
      "thousands_separator": ".",
      "iso_numeric": "704"
},
      "vuv": {
      "priority": 100,
      "iso_code": "VUV",
      "name": "Vanuatu Vatu",
      "symbol": "Vt",
      "alternate_symbols": [],
      "subunit": null,
      "subunit_to_unit": 1,
      "symbol_first": true,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "548"
},
      "wst": {
      "priority": 100,
      "iso_code": "WST",
      "name": "Samoan Tala",
      "symbol": "T",
      "alternate_symbols": ["WS$", "SAT", "ST"],
      "subunit": "Sene",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "882"
},
      "xaf": {
      "priority": 100,
      "iso_code": "XAF",
      "name": "Central African Cfa Franc",
      "symbol": "Fr",
      "alternate_symbols": ["FCFA"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "950"
},
      "xag": {
      "priority": 100,
      "iso_code": "XAG",
      "name": "Silver (Troy Ounce)",
      "symbol": "oz t",
      "alternate_symbols": [],
      "subunit": "oz",
      "subunit_to_unit": 1,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "961"
},
      "xau": {
      "priority": 100,
      "iso_code": "XAU",
      "name": "Gold (Troy Ounce)",
      "symbol": "oz t",
      "alternate_symbols": [],
      "subunit": "oz",
      "subunit_to_unit": 1,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "959"
},
      "xcd": {
      "priority": 100,
      "iso_code": "XCD",
      "name": "East Caribbean Dollar",
      "symbol": "$",
      "alternate_symbols": ["EC$"],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "951"
},
      "xdr": {
      "priority": 100,
      "iso_code": "XDR",
      "name": "Special Drawing Rights",
      "symbol": "SDR",
      "alternate_symbols": ["XDR"],
      "subunit": "",
      "subunit_to_unit": 1,
      "symbol_first": false,
      "html_entity": "$",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "960"
},
      "xof": {
      "priority": 100,
      "iso_code": "XOF",
      "name": "West African Cfa Franc",
      "symbol": "Fr",
      "alternate_symbols": ["CFA"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "952"
},
      "xpf": {
      "priority": 100,
      "iso_code": "XPF",
      "name": "Cfp Franc",
      "symbol": "Fr",
      "alternate_symbols": ["F"],
      "subunit": "Centime",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "953"
},
      "yer": {
      "priority": 100,
      "iso_code": "YER",
      "name": "Yemeni Rial",
      "symbol": "﷼",
      "alternate_symbols": [],
      "subunit": "Fils",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "&#xFDFC;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "886"
},
      "zar": {
      "priority": 100,
      "iso_code": "ZAR",
      "name": "South African Rand",
      "symbol": "R",
      "alternate_symbols": [],
      "subunit": "Cent",
      "subunit_to_unit": 100,
      "symbol_first": true,
      "html_entity": "&#x0052;",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "710"
},
      "zmk": {
      "priority": 100,
      "iso_code": "ZMK",
      "name": "Zambian Kwacha",
      "symbol": "ZK",
      "alternate_symbols": [],
      "subunit": "Ngwee",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "894"
},
      "zmw": {
      "priority": 100,
      "iso_code": "ZMW",
      "name": "Zambian Kwacha",
      "symbol": "ZK",
      "alternate_symbols": [],
      "subunit": "Ngwee",
      "subunit_to_unit": 100,
      "symbol_first": false,
      "html_entity": "",
      "decimal_mark": ".",
      "thousands_separator": ",",
      "iso_numeric": "967"
}
}';

  private $options = array();

  public function __construct() {
    $this->options = json_decode($this->json);
  }

  public function getOptions() {
    return $this->options;
  }

  public function getCurrency($code) {
    return isset($this->options->{$code}) ? $this->options->{$code} : false;
  }

  public function get($code, $type) {
    $object = $this->getCurrency($code);

    if (is_object($object))
    return is_object($object) && isset($object->{$type}) ? $object->{$type} : false;
  }
}