<?php

/**
 * Extending VTCore default shortcodes models
 * to add processor relevant to visual composer.
 *
 * @author jason.xie@victheme.com
 */
abstract class VTCore_Wordpress_Models_VCShortcodes
    extends VTCore_Wordpress_Models_Shortcodes
{

    protected function processVC()
    {
        // Preprocessing VC custom css from the design tabs
        if ($this->get('css') && function_exists('vc_shortcode_custom_css_class')) {
            $this->add('attributes.class.visualcomposer_css_style', trim(vc_shortcode_custom_css_class($this->get('css'), ' ')));
            $this->remove('css');
        }

        // Support for css animation
        if ($this->get('css_animation')) {

            if (wp_script_is('waypoints', 'registered') == false) {
                wp_register_script('waypoints', vc_asset_url('lib/jquery-waypoints/waypoints.min.js'), array('jquery'), WPB_VC_VERSION, true);
            }

            wp_enqueue_script('waypoints');

            if (wp_style_is('animate-css', 'registered') == false) {
                wp_register_style('animate-css', vc_asset_url('lib/bower/animate-css/animate.min.css'), array(), WPB_VC_VERSION);
            }

            wp_enqueue_style('animate-css');

            $this
                ->add('attributes.class.css_animation', 'wpb_animate_when_almost_visible ' . $this->get('css_animation'))
                ->remove('css_animation');
        }

        return $this;
    }

    protected function preprocessAtts($atts)
    {
        parent::preprocessAtts($atts);
        if (defined('WPB_VC_VERSION')) {
            $this->processVC();
        }
        return $this->atts;
    }

}