<?php

/**
 * Class extending the Shortcodes base class
 * for building the memorylineinner element
 *
 * how to use :
 * [memorylineinner
 *   id="x"
 *   class="class_one class_two"
 *   dotcolor="the color for the dotted end"
 *   titlecolor="the title color"
 *   textcolor="the text color"
 *   title="the title text"
 *
 *   mobile_column="X"
 *   tablet_column="X"
 *   small_column="X"
 *   large_column="X"
 *   mobile_offset="X"
 *   tablet_offset="X"
 *   small_offset="X"
 *   large_offset="X"
 *   mobile_push="X"
 *   tablet_push="X"
 *   small_push="X"
 *   large_push="X"
 *   mobile_pull="X"
 *   tablet_pull="X"
 *   small_pull="X"
 *   large_pull="X"
 *
 *   text_element___grids___columns___mobile="X"
 *   text_element___grids___columns___tablet="X"
 *   text_element___grids___columns___small="X"
 *   text_element___grids___columns___large="X"
 *   text_element___grids___offset___mobile="X"
 *   text_element___grids___offset___tablet="X"
 *   text_element___grids___offset___small="X"
 *   text_element___grids___offset___large="X"
 *   text_element___grids___push___mobile="X"
 *   text_element___grids___push___tablet="X"
 *   text_element___grids___push___small="X"
 *   text_element___grids___push___large="X"
 *   text_element___grids___pull___mobile="X"
 *   text_element___grids___pull___tablet="X"
 *   text_element___grids___pull___small="X"
 *   text_element___grids___pull___large="X"
 * 
 *   title_element___grids___columns___mobile="X"
 *   title_element___grids___columns___tablet="X"
 *   title_element___grids___columns___small="X"
 *   title_element___grids___columns___large="X"
 *   title_element___grids___offset___mobile="X"
 *   title_element___grids___offset___tablet="X"
 *   title_element___grids___offset___small="X"
 *   title_element___grids___offset___large="X"
 *   title_element___grids___push___mobile="X"
 *   title_element___grids___push___tablet="X"
 *   title_element___grids___push___small="X"
 *   title_element___grids___push___large="X"
 *   title_element___grids___pull___mobile="X"
 *   title_element___grids___pull___tablet="X"
 *   title_element___grids___pull___small="X"
 *   title_element___grids___pull___large="X"
 * 
 *   data___dot_direction="x"
 *   data___dot_radius="x"
 *   data___dot_color="x"
 *   data___dot_offset_x="x"
 *   data___dot_offset_y="x"
 *   data___line_color="x"
 *   data___line_width="x"
 *   data___line_type="x"
 * ]
 *
 *   some content for the inner shortcodes allowed
 *
 * [/memorylineinner]
 *
 * This shortcode must be inside the memoryline shortcode
 * otherwise it will produce invalid HTML markup
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_MemoryLine_Shortcodes_MemoryLineInner
    extends VTCore_Wordpress_Models_VCShortcodes
    implements VTCore_Wordpress_Interfaces_Shortcodes
{
    protected $processDottedNotation = true;

    public function processCustomRules()
    {

        $this->convertVCGrid = true;
        
        if ($this->get('titlecolor')) {
            $this->add('title_element.styles.color', $this->get('titlecolor'));
        }

        if ($this->get('title')) {
            $this->add('title_element.text', $this->get('title'));
        }

        if ($this->get('textcolor')) {
            $this->add('text_element.styles.color', $this->get('textcolor'));
        }

        foreach ($this->extract() as $key => $value) {
            if (strpos($key, 'data___') !== false) {
                list($type, $mode) = explode('___', $key);
                $this->add('data.' . str_replace('_', '-', $mode), $value);
            }
        }

        $this
            ->add('text_element.text', do_shortcode($this->content))
            ->remove('title')
            ->remove('titlecolor')
            ->remove('titlecss')
            ->remove('textcolor')
            ->remove('textcss')
            ->remove('data.dot-direction')
            ->remove('data.dot-direction');
    }

    public function buildObject()
    {
        $this->object = new VTCore_MemoryLine_Element_MlInner($this->atts);
    }
}