<?php

/**
 * Class extending the Shortcodes base class
 * for building the snakeline element
 *
 * how to use :
 *
 * [snakeline
 * class="some class"
 * id="someid"
 * line___color=""
 * line___width=""
 * line___type=""
 * ]
 *
 * [snakelineitem
 * id="x"
 * class="class_one class_two"
 * date___text="2016"
 * date___color=""
 * content___text="the context text"
 * content___color=""
 * dot___link=""
 * dot___color=""
 * dot___background=""
 * dot___text=""
 * ]
 *
 * some content for the inner shortcodes allowed
 *
 * [/snakelineitem]
 *
 * [/snakeline]
 *
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_SnakeLine_Shortcodes_SnakeLine
    extends VTCore_Wordpress_Models_VCShortcodes
    implements VTCore_Wordpress_Interfaces_Shortcodes
{

    protected $booleans = array(
        'animate'
    );

    protected $processDottedNotation = true;

    protected function processCustomRules()
    {
        if (!$this->get('direction')) {
            $this->add('direction', 'horizontal');
        }

        if ($this->get('animate')) {
            $this->add('attributes.class.animation', 'snakeline-with-animation');
        }

        $this->add('attributes.class.direction', 'snakeline-direction-' . $this->get('direction'));
    }

    public function buildObject()
    {
        $this->object = new VTCore_SnakeLine_Element_SnakeLine($this->atts);
        $this->object->addChildren(do_shortcode($this->content));
    }
}