<?php

/**
 * Class extending the Shortcodes base class
 * for building simple snake line. This is created
 * for a very simple snake line object for advanced
 * usage please us the normal snakeline shortcode instead.
 *
 * how to use :
 *
 * [snakelinesimple
 *   class="some class"
 *   id="someid"
 *   contentargs="url decoded arrays of content"
 * ]
 *
 *
 * @author jason.xie@victheme.com
 *
 */
class VTCore_SnakeLine_Shortcodes_SnakeLineSimple
    extends VTCore_Wordpress_Models_VCShortcodes
    implements VTCore_Wordpress_Interfaces_Shortcodes
{

    protected $booleans = array(
        'animate'
    );

    protected $processDottedNotation = true;

    /**
     * Extending parent method.
     * @see VTCore_Wordpress_Models_Shortcodes::processCustomRules()
     */
    protected function processCustomRules()
    {
        if ($this->get('contentargs')) {
            $this->add('contents', json_decode(urldecode($this->get('contentargs')), true));
        }

        if (!$this->get('direction')) {
            $this->add('direction', 'horizontal');
        }

        if ($this->get('animate')) {
            $this->add('attributes.class.animation', 'snakeline-with-animation');
        }

        $this->add('attributes.class.direction', 'snakeline-direction-' . $this->get('direction'));
    }


    public function buildObject()
    {

        $animation = $this->get('attributes.class.css_animation');
        if ($animation) {
            $this->remove('attributes.class.css_animation');
        }

        $this->object = new VTCore_SnakeLine_Element_SnakeLine($this->atts);

        if ($this->get('contents')) {
            foreach ($this->get('contents') as $delta => $content) {
                $markup = '';
                $data = new VTCore_Wordpress_Objects_Array($content);
                if ($animation) {
                    $data->add('attributes.class.css_animation', $animation);
                }
                $shortcode = new VTCore_SnakeLine_Shortcodes_SnakeLineItem($data->extract(), $data->get('content'), 'snakelineitem');
                $shortcode->buildObject();
                $markup .= $shortcode->getMarkup();

                unset($data);
                $data = NULL;

                unset($shortcode);
                $shortcode = NULL;

                if (!empty($markup)) {
                    $this->object->addChildren($markup);
                }
            }
        }
    }
}


